const fs = require('fs');

function readJSON (filePath) {

  return new Promise((resolve, reject) => {

    fs.readFile(filePath, 'utf-8', function (err, data) {

      try {
        if(err) throw err;
        resolve(JSON.parse(data));
      } catch(e) { resolve({}) };
    });
  });
}

/**
 * 监听 JSON 文件变化
 * 
 * @param {string} filePath - 文件路径
 * @param {function} fn - 回调函数
 */
function wacthJSON (filePath, fn) {

  let delay = false;
  fs.watchFile(filePath, function (event, filename) {

    if(delay) return ;
    
    readJSON(filePath).then(function (data) {
      fn(data);
    });

    delay = true , setTimeout(() => {
      delay = false;
    }, 100);
  });
}

module.exports = wacthJSON;